/**
 * <h1>CallGenerator</h1>
 *
 * <p>Generate code for a call.</p>
 *
 * <p>Copyright (c) 2018 by Ronald Mak</p>
 * <p>For instructional purposes only.  No warranties.</p>
 */
#include "CallGenerator.h"
#include "StatementGenerator.h"
#include "CallDeclaredGenerator.h"
#include "CallStandardGenerator.h"
#include "../CodeGenerator.h"
#include "../../../Object.h"
#include "../../../intermediate/SymTabEntry.h"
#include "../../../intermediate/symtabimpl/SymTabEntryImpl.h"
#include "../../../intermediate/ICodeNode.h"
#include "../../../intermediate/icodeimpl/ICodeNodeImpl.h"

namespace wci { namespace backend { namespace compiler { namespace generators {

using namespace std;
using namespace wci::backend::compiler;
using namespace wci::intermediate;
using namespace wci::intermediate::symtabimpl;
using namespace wci::intermediate::icodeimpl;

void CallGenerator::generate(ICodeNode *node)
{
    SymTabEntry *routine_id = node->get_id();
    RoutineCode routine_code = routine_id->get_routine_code();

    if (routine_code == (RoutineCode) RT_DECLARED)
    {
        CallDeclaredGenerator call_generator(this);
        call_generator.generate(node);
    }
    else
    {
        CallStandardGenerator call_generator(this);
        call_generator.generate(node);
    }
}

}}}}  // namespace wci::backend::compiler::generators
