/**
 * <h1>CallGenerator</h1>
 *
 * <p>Generate code for a call.</p>
 *
 * <p>Copyright (c) 2018 by Ronald Mak</p>
 * <p>For instructional purposes only.  No warranties.</p>
 */
#ifndef CALLGENERATOR_H_
#define CALLGENERATOR_H_

#include "StatementGenerator.h"
#include "../CodeGenerator.h"
#include "../../../intermediate/ICodeNode.h"

namespace wci { namespace backend { namespace compiler { namespace generators {

using namespace std;
using namespace wci::intermediate;
using namespace wci::backend::compiler;

class CallGenerator : public StatementGenerator
{
public:
    /**
     * Constructor.
     * @param the parent executor.
     */
    CallGenerator(CodeGenerator *parent) : StatementGenerator(parent) {}

    /**
     * Generate code to call a procedure or function.
     * @param node the root node of the call.
     */
    void generate(ICodeNode *node);
};

}}}}  // namespace wci::backend::compiler::generators

#endif /* CALLGENERATOR_H_ */
