/**
 * <h1>IfGenerator</h1>
 *
 * <p>Generate code for an IF statement.</p>
 *
 * <p>Copyright (c) 2018 by Ronald Mak</p>
 * <p>For instructional purposes only.  No warranties.</p>
 */
#ifndef WCI_BACKEND_COMPILER_GENERATORS_IFGENERATOR_H_
#define WCI_BACKEND_COMPILER_GENERATORS_IFGENERATOR_H_

#include <string>
#include "StatementGenerator.h"
#include "../CodeGenerator.h"
#include "../../../intermediate/ICodeNode.h"

namespace wci { namespace backend { namespace compiler { namespace generators {

using namespace std;
using namespace wci::intermediate;
using namespace wci::backend::compiler;

class IfGenerator : public StatementGenerator
{
public:
    /**
     * Constructor.
     * @param the parent executor.
     */
    IfGenerator(CodeGenerator *parent);

    /**
     * Generate code for an IF statement.
     * @param node the root node of the statement.
     * @throw a string message if an error occurred.
     */
    void generate(ICodeNode *node) throw (string);
};

}}}}  // namespace wci::backend::compiler::generators

#endif /* WCI_BACKEND_COMPILER_GENERATORS_IFGENERATOR_H_ */
