/**
 * <h1>LoopGenerator</h1>
 *
 * <p>Generate code for a looping statement.</p>
 *
 * <p>Copyright (c) 2018 by Ronald Mak</p>
 * <p>For instructional purposes only.  No warranties.</p>
 */
#ifndef WCI_BACKEND_COMPILER_GENERATORS_LOOPGENERATOR_H_
#define WCI_BACKEND_COMPILER_GENERATORS_LOOPGENERATOR_H_

#include <string>
#include "StatementGenerator.h"
#include "../CodeGenerator.h"
#include "../../../intermediate/ICodeNode.h"

namespace wci { namespace backend { namespace compiler { namespace generators {

using namespace std;
using namespace wci::intermediate;
using namespace wci::backend::compiler;

class LoopGenerator : public StatementGenerator
{
public:
    /**
     * Constructor.
     * @param the parent executor.
     */
    LoopGenerator(CodeGenerator *parent);

    /**
     * Generate code for a looping statement.
     * @param node the root node of the statement.
     * @throw a string message if an error occurred.
     */
    void generate(ICodeNode *node) throw (string);
};

}}}}  // namespace wci::backend::compiler::generators

#endif /* WCI_BACKEND_COMPILER_GENERATORS_LOOPGENERATOR_H_ */
